/*
some code possibly from simonc
some code possibly from peteru
some code possibly from deadbeef
some code possibly from berlios
some code possibly from iceepg
possibly some code from elsewhere ...
*/
/*
Portions of this code may be covered under the GNU General Public License. Any
such code is likely to have been modified, possibly beyond recognition, but is
still covered under this license. All other portions are free from any license.

        Some portions may be:
        Copyright (C) 2005 Simon Capewell, http://tap.berlios.de/
        Copyright (C) 2004-2005 Peter Urbanec. All Rights Reserved. http://tap.berlios.de/
        Copyright (C) 2005 DeadBeef, http://de.geocities.com/deadbeef55/
        Copyright (C) 2005 IceTv Pty Limited, http://www.icetv.com.au/
        Copyright (C) 2005 Tony H, http://tonyspage.dyndns.org/

        This is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        The software is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this software; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
    v0.01 - initial release
    v0.02 - added exTAP_EPG_GetNumEvents()
          - removed runningStatus from exTAP_EPG_DeleteEvent()
          - updated for firmware v12.25
    v0.03 - added exTAP_MHEG_Status()
          - added exTAP_GetFirmwareAddress()
          - added exTAP_EPG_Resize()
          - added exTAP_EPG_GetSize()
          - added TAP_Hdd_Move()
    v0.04 - fixed leak int exTAP_EPG_GetSize()
          - fixed bug in hook code trashing $gp when multiple taps active
    v0.05 - added TAP_GetTuner()
          - changed exTAP_CallFirmware() to pass in 11 arguments rather than 4
          - added exTAP_isPatched()
          - added exTAP_MHEG_isPatched()
          - added exTAP_EIT_Schedule()
          - added exTAP_EIT_NowNext()
          - added exTAP_EPG_Stick()
          - added sysid to type_patch/type_hook
          - separated firmware addresses to autogenerated patches.h/patches.c
            support for many firmwares, using generate_patches.exe
    v0.06 - updated for firmware v12.88
          - removed prints (use #define exTAPdebug
          - better error reporting (still more to do)
          - added TAP_Channel_StopMainSub()
          - added TAP_undoc11()
          - added TAP_Channel_SwapMainSub()
          - fixed hooks to support any firmware
          - added exTAP_GetCurrentGenre()
          - added exTAP_GetGenre()
          - added exTAP_CallTap()
          - added exTAP_SendMessage()
    v.07  - fixed extended event handling
          -
*/
/*
conventions:
return values:
    -ve   = error
    0,+ve = no_error
*/

#include <tap.h>
#include "exTap.h"
#include "patches.h"


//----------------------------------------------------------------------------
word fw_sysid = 0;

dword fw_tap_table = 0;
dword fw_tap_ident = 0;
dword fw_gp = 0;
void *fw_os_free = 0;
void *fw_add_task_queue = 0;
void *fw_shutdown_irq_disable = 0;
void *fw_shutdown_irq_enable = 0;
void *fw_shutdown_task = 0;
void *fw_process_tdt = 0;
type_taptime *fw_utc_time = 0;
void *fw_utctolocal_time = 0;
void *fw_process_eit = 0;
void *fw_TAP_GetCurrentEvent = 0;
type_eventtable *fw_event_table = 0;
int fw_event_table_size = 0;
int fw_max_events = 0;
void *fw_event_alloc = 0;
type_eventbuffer *fw_event_buffer = 0;
void *fw_event_delete = 0;
void *fw_process_dsmcc = 0;
dword *fw_mheg_entry = 0;
dword fw_mheg_off_patch = 0;
void *fw_hdd_move = 0;
dword fw_key_map_patch = 0;
void *fw_display_func = 0;
char * fw_display_string = 0;
void *fw_tap_load = 0;
dword *fw_tap_load_data0 = 0;
dword *fw_tap_load_data1 = 0;
dword *fw_tap_load_data2 = 0;
int fw_num_ext_functions = 0;
dword *fw_ext_function_table = 0;

//undocumented tap functions
int   (*TAP_Channel_StopMainSub)(void);             //TAP_Channel_StopMainSub(), returns 1;
void  (*TAP_undoc11)(int mode, int enable);         //disable/enable pop up [0=info,1=pip,2-volume,3=no signal]

//extended tap functions
int   (*TAP_Hdd_ReadSectorDMA)(int mode, word, byte *buffer);
int   (*TAP_Hdd_WriteSectorDMA)(int mode, word, byte *buffer);
void  (*TAP_unknown2)(void);
int   (*TAP_Hdd_unknown3)(int);
byte  (*TAP_GetTuner)(int mainSub);
dword (*TAP_Hdd_Move)(char *from_dir, char *to_dir, char *filename);
int   (*TAP_Osd_unknown20)(dword *);
int   (*TAP_Channel_SwapMainSub)(void);

//----------------------------------------------------------------------------
//non exported functions
int   exTAP_ApplyPatch2(type_patch2 *patch);
int   exTAP_RemovePatch2(type_patch2 *patch);
int   exTAP_ApplyPatch3(dword addr, byte *from, byte *to, int length);
extern dword *patch_hook_main;

//----------------------------------------------------------------------------
int exTAP_Init(void)
{
    type_TAPProcess *TAPProcess;

//
//set the firmeware addresses
//
    fw_sysid = *(word*)pSysID;

//these ones are critical (required)
//the fw_xxx variables are later used unchecked, so if null, will cause a crash
//
    fw_tap_ident = exTAP_GetFirmwareAddress(fwlist_tap_ident);
    if (fw_tap_ident <= 0) goto exit;

    fw_tap_table = exTAP_GetFirmwareAddress(fwlist_tap_table);
    if (fw_tap_table <= 0) goto exit;

    fw_gp = exTAP_GetFirmwareAddress(fwlist_gp);
    if (fw_gp <= 0) goto exit;

    fw_event_buffer = (type_eventbuffer *)exTAP_GetFirmwareAddress(fwlist_event_buffer);
    if (fw_event_buffer <= 0) goto exit;

    fw_event_table = (type_eventtable *)exTAP_GetFirmwareAddress(fwlist_event_table);
    if (fw_event_table <= 0) goto exit;

    fw_event_table_size = (int)exTAP_GetFirmwareAddress(fwlist_event_table_size);
    if (fw_event_table_size <= 0) goto exit;

    fw_max_events = (int)exTAP_GetFirmwareAddress(fwlist_max_events);
    if (fw_max_events <= 0) goto exit;

    fw_event_delete = (void *)exTAP_GetFirmwareAddress(fwlist_event_delete);
    if (fw_event_delete <= 0) goto exit;

    fw_event_alloc = (void *)exTAP_GetFirmwareAddress(fwlist_event_alloc);
    if (fw_event_alloc <= 0) goto exit;

    fw_os_free = (void *)exTAP_GetFirmwareAddress(fwlist_os_free);
    if (fw_os_free <= 0) goto exit;

    fw_utc_time = (type_taptime *)exTAP_GetFirmwareAddress(fwlist_utc_time);
    if (fw_utc_time <= 0) goto exit;

    fw_utctolocal_time = (void *)exTAP_GetFirmwareAddress(fwlist_utctolocal_time);
    if (fw_utctolocal_time <= 0) goto exit;

//
//these ones are not critical (optional)
//the fw_xxx variables are always checked before being used, so if null, will be ok
//
    TAPProcess = (type_TAPProcess *)(fw_tap_table + ((*(dword *)fw_tap_ident)*32));

    TAP_Channel_StopMainSub = TAPProcess->entryPoints->pTAP_Channel_StopMainSub;
    TAP_undoc11 = TAPProcess->entryPoints->pTAP_undoc11;

    TAP_Hdd_ReadSectorDMA = TAP_GetSystemProc(oTAP_Hdd_ReadSectorDMA);
    TAP_Hdd_WriteSectorDMA = TAP_GetSystemProc(oTAP_Hdd_WriteSectorDMA);
    TAP_unknown2      = TAP_GetSystemProc(oTAP_unknown2);
    TAP_Hdd_unknown3  = TAP_GetSystemProc(oTAP_Hdd_unknown3);
    TAP_GetTuner      = TAP_GetSystemProc(oTAP_GetTuner);
    TAP_Hdd_Move      = TAP_GetSystemProc(oTAP_Hdd_Move);
    TAP_Osd_unknown20 = TAP_GetSystemProc(oTAP_Osd_unknown20);
    TAP_Channel_SwapMainSub = TAP_GetSystemProc(oTAP_Channel_SwapMainSub);                  //1288 only

    fw_add_task_queue = (void *)exTAP_GetFirmwareAddress(fwlist_add_task_queue);
    fw_mheg_entry = (dword *)exTAP_GetFirmwareAddress(fwlist_mheg_entry);
    fw_hdd_move = (void *)exTAP_GetFirmwareAddress(fwlist_hdd_move);
    fw_shutdown_irq_enable = (void *)exTAP_GetFirmwareAddress(fwlist_shutdown_irq_enable);
    fw_shutdown_irq_disable = (void *)exTAP_GetFirmwareAddress(fwlist_shutdown_irq_disable);
    fw_shutdown_task = (void *)exTAP_GetFirmwareAddress(fwlist_shutdown_task);
    fw_tap_load = (void *)exTAP_GetFirmwareAddress(fwlist_tap_load);
    fw_tap_load_data0 = (dword *)exTAP_GetFirmwareAddress(fwlist_tap_load_data0);
    fw_tap_load_data1 = (dword *)exTAP_GetFirmwareAddress(fwlist_tap_load_data1);
    fw_tap_load_data2 = (dword *)exTAP_GetFirmwareAddress(fwlist_tap_load_data2);
    fw_display_string = (char *)exTAP_GetFirmwareAddress(fwlist_display_string);
    fw_display_func = (void *)exTAP_GetFirmwareAddress(fwlist_display_func);


    //set the address of tap_ident, tap_table in hook_main()
    *(word *)((dword)&patch_hook_main+2) = ((dword)fw_tap_ident >> 16) & 0xffff;
    *(word *)((dword)&patch_hook_main+6) = ((dword)fw_tap_ident >> 00) & 0xffff;
    *(word *)((dword)&patch_hook_main+10) = ((dword)fw_tap_table >> 16) & 0xffff;
    *(word *)((dword)&patch_hook_main+14) = ((dword)fw_tap_table >> 00) & 0xffff;

    return 0;

exit:
#ifdef exTAPdebug
    TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
    TAP_Print("\n");
#endif
    return EXTAPERR_BAD_FIRMWARE;
}


#define MAX_FIRMWARE_REVISIONS 0x20

dword exTAP_GetFirmwareAddress(type_firmware *firmware)
{
    int i;

    for (i=0; i<MAX_FIRMWARE_REVISIONS; i++) {
        if (firmware[i].sysid == fw_sysid) {
            if (firmware[i].revision > 0) {
                if (firmware[i].revision == _appl_version) {
                    if (firmware[i].address) return firmware[i].address;
                }
            }
        }
        else if (firmware[i].sysid == 0) {
            break;
        }
    }
#ifdef exTAPdebug
    TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
    return EXTAPERR_BAD_FIRMWARE;
}

//----------------------------------------------------------------------------
/*
for reference, gcc inline requires a numeric register naming convention
$0    0         $t0   8         $s0  16             $t8  24
$at,$1   1      $t1   9         $s1  17             $t9  25
$v0   2         $t2  10         $s2  18             $k0  26
$v1   3         $t3  11         $s3  19             $k1  27
$a0   4         $t4  12         $s4  20             $gp  28
$a1   5         $t5  13         $s5  21             $sp  29
$a2   6         $t6  14         $s6  22         $s8,$fp  30
$a3   7         $t7  15         $s7  23             $ra  31
*/
//what is the order for registers after a0,a1,a2,a3, ... - uses stack
dword exTAP_CallFirmware(void *pFunction, dword p0, dword p1, dword p2, dword p3, dword p4, dword p5, dword p6, dword p7, dword p8, dword p9, dword p10)
{
    // The function has to be implemented in assembler in order to
    // gain full control over register usage.
    // The firmware makes use of the $gp register which contains
    // a different value when running in TAP context.
    __asm__ __volatile__ (
    "addiu   $sp,$sp,0xffc8\n"                            //addiu   $sp,$sp,-0x38
    "sw      $31,0x0030($sp)\n"                           //sw      $ra,0x0014($sp)         save ra
    "sw      $22,0x0034($sp)\n"                           //sw      $s6,0x0018($sp)         save s6

    "or      $15,%0,$00\n"                                //or      $t7,tap_ident,$00       ptr to tap_ident
    "or      $22,%1,$00\n"                                //or      $s6,tap_table,$00       ptr to tap_table

    "or      $08,$00,%2\n"                                //or      $t0,$00,pFunction       beware of the order here ...
    "or      $04,$00,%3\n"                                //or      $a0,$00,p0
    "or      $05,$00,%4\n"                                //or      $a1,$00,p1
    "or      $06,$00,%5\n"                                //or      $a2,$00,p2
    "lw      $07, 0x40+0x14($sp)\n"                       //
    "sw      $07, 0x10($sp)\n"                            //p4
    "lw      $07, 0x40+0x18($sp)\n"                       //
    "sw      $07, 0x14($sp)\n"                            //p5
    "lw      $07, 0x40+0x1c($sp)\n"                       //
    "sw      $07, 0x18($sp)\n"                            //p6
    "lw      $07, 0x40+0x20($sp)\n"                       //
    "sw      $07, 0x1c($sp)\n"                            //p7
    "lw      $07, 0x40+0x24($sp)\n"                       //
    "sw      $07, 0x20($sp)\n"                            //p8
    "lw      $07, 0x40+0x28($sp)\n"                       //
    "sw      $07, 0x24($sp)\n"                            //p9
    "lw      $07, 0x40+0x2c($sp)\n"                       //
    "sw      $07, 0x28($sp)\n"                            //p10

    "lw      $07, 0x40+0x10($sp)\n"                       //$a3     p3

    "lw      $15,0x0000($15)\n"                           //lw      $t7,0x0000($t7)         get tap_ident
    "sll     $15,$15,0x05\n"                              //sll     $t7,$t7,0x05            tap_ident * 32
    "addu    $22,$22,$15\n"                               //addu    $s6,$s6,$t7             offset to this taps tap_table

    "lw      $03,0x0000($22)\n"                           //lw      $v1,0x0000($s6)         get firmware gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             set gp

    "jal     $08\n"                                       //jal     $t0                     call function(p0, p1, p2, p3)

    "lw      $03,0x0004($22)\n"                           //lw      $v1,0x0004($s6)         get tap gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             restore gp

    "lw      $31,0x0030($sp)\n"                           //lw      $ra,0x0014($sp)         restore ra
    "lw      $22,0x0034($sp)\n"                           //lw      $s6,0x0018($sp)         restore s6
    "addiu   $sp,$sp,0x0038\n"                            //addiu   $sp,$sp,0x38
    :
    : "r"(fw_tap_ident), "r"(fw_tap_table), "r"(pFunction), "r"(p0), "r"(p1), "r"(p2));
}

dword exTAP_CallTap(int ident, void *pFunction, dword p0, dword p1, dword p2, dword p3, dword p4, dword p5, dword p6, dword p7, dword p8, dword p9, dword p10)
{
    // The function has to be implemented in assembler in order to
    // gain full control over register usage.
    // The firmware makes use of the $gp register which contains
    // a different value when running in TAP context.

//save the current tap id
//select the require tap context
//call the function
//restore the $gp
    __asm__ __volatile__ (
    "addiu   $sp,$sp,0xffbc\n"                            //addiu   $sp,$sp,-0x44
    "sw      $31,0x0030($sp)\n"                           //sw      $ra,0x0014($sp)         save ra
    "sw      $22,0x0034($sp)\n"                           //sw      $s6,0x0018($sp)         save s6
    "sw      $23,0x0038($sp)\n"                           //sw      $s7,0x001c($sp)         save s7

    "or      $23,%0,$00\n"                                //or      $s7,tap_ident,$00       ptr to tap_ident
    "or      $22,%1,$00\n"                                //or      $s6,tap_table,$00       ptr to tap_table

//save the current tap id
    "lw      $15,0x0000($23)\n"                           //lw      $t7,0x0000($s7)         get tap_ident
    "sw      $15,0x003c($sp)\n"                           //sw      $t7,0x0020($sp)         save tap_ident
    "sw      $28,0x0040($sp)\n"                           //sw      $gp,0x0024($sp)         save gp

    "or      $15,$00,%2\n"                                //or      $t7,$00,id              beware of the order here ...
    "or      $08,$00,%3\n"                                //or      $t0,$00,pFunction
    "or      $04,$00,%4\n"                                //or      $a0,$00,p0
    "or      $05,$00,%5\n"                                //or      $a1,$00,p1
    "lw      $06, 0x4c+0x10($sp)\n"                       //$a2     p2

    "lw      $07, 0x4c+0x18($sp)\n"                       //
    "sw      $07, 0x10($sp)\n"                            //p4
    "lw      $07, 0x4c+0x1c($sp)\n"                       //
    "sw      $07, 0x14($sp)\n"                            //p5
    "lw      $07, 0x4c+0x20($sp)\n"                       //
    "sw      $07, 0x18($sp)\n"                            //p6
    "lw      $07, 0x4c+0x24($sp)\n"                       //
    "sw      $07, 0x1c($sp)\n"                            //p7
    "lw      $07, 0x4c+0x28($sp)\n"                       //
    "sw      $07, 0x20($sp)\n"                            //p8
    "lw      $07, 0x4c+0x2c($sp)\n"                       //
    "sw      $07, 0x2c($sp)\n"                            //p9
    "lw      $07, 0x4c+0x30($sp)\n"                       //
    "sw      $07, 0x28($sp)\n"                            //p10

    "lw      $07, 0x4c+0x14($sp)\n"                       //$a3     p3

//set the new tap id
    "sw      $15,0x0000($23)\n"                           //sw      $t7,0x0000($s7)         set tap_ident

    "sll     $15,$15,0x05\n"                              //sll     $t7,$t7,0x05            tap_ident * 32
    "addu    $22,$22,$15\n"                               //addu    $s6,$s6,$t7             offset to this taps tap_table

    "lw      $03,0x0004($22)\n"                           //lw      $v1,0x0004($s6)         get tap gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             set gp

    "jal     $08\n"                                       //jal     $t0                     call function(p0, p1, p2, p3)

    "lw      $03,0x0040($sp)\n"                           //lw      $v1,0x0040($sp)         get original gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             restore gp

    "lw      $15,0x003c($sp)\n"                           //lw      $t7,0x0040($sp)         get tap_ident
    "sw      $15,0x0000($23)\n"                           //sw      $t7,0x0000($s7)         restore tap_ident

    "lw      $23,0x0038($sp)\n"                           //lw      $s7,0x001c($sp)         restore s7
    "lw      $22,0x0034($sp)\n"                           //lw      $s6,0x0018($sp)         restore s6
    "lw      $31,0x0030($sp)\n"                           //lw      $ra,0x0014($sp)         restore ra
    "addiu   $sp,$sp,0x0044\n"                            //addiu   $sp,$sp,0x44
    :
    : "r"(fw_tap_ident), "r"(fw_tap_table), "r"(ident), "r"(pFunction), "r"(p0), "r"(p1));
}

//
//send the message to all taps
//
int exTAP_SendMessage(dword param1, dword param2)
{
    int i;
    int ret;
    type_TAPProcess *TAPProcess;

    for (i=0; i<16; i++) {
        //dont call ourselves
//        if (i == *fw_tap_ident) {
//        }
//        else {
            TAPProcess = (type_TAPProcess *)(fw_tap_table + (i*32));
            if (TAPProcess->firmwaregp) {
                if (TAPProcess->header) {
                    ret = exTAP_CallTap(i, (void *)(TAPProcess->entryPoints->TAP_EventHandler), (dword)EVT_MESSAGE, (dword)param1, (dword)param2, 0,0,0,0,0,0,0,0);
                    //if ret = 0, don't send to any more taps
                    if (ret == 0) return 0;
                }
            }
//        }
    }
    return ret; //return value from last tap
}

//can be in 3 states
//EXTAPERR_ALREADY_PATCHED - correctly patched
//EXTAPERR_NOT_PATCHED     - unpatched
//EXTAPERR_BAD_MATCH       - neither
int exTAP_isPatched(type_patch *patch, int *index)
{
    int i,j;
    int match;

    //search though the list looking for a sysid/version match
    if (index) *index = 0;
    match = 0;
    j = 0;
    while (patch[j].sysid) {
        //check firmware version
        if ((patch[j].sysid == fw_sysid) && (patch[j].revision == _appl_version)) {
            match = 1;
            break;
        }
        j++;
    }
    if (!match) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
        TAP_Print("\n");
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }
    if (index) *index = j;

    //check if unpatched
    for (i=0; i<patch[j].count; i++) {
        if (*(dword *)(patch[j].info[i].addr) == *(dword *)(patch[j].info[i].from)) {
            if (i == (patch[j].count-1)) {
#ifdef exTAPdebug
                TAP_Print("\n%s(), Firmware is not patched: 0x%08x", __func__, patch[j].info[0].addr);
#endif
                return EXTAPERR_NOT_PATCHED;
            }
        }
        else {
            break;
        }
    }

    //check if firmware is already patched
    for (i=0; i<patch[j].count; i++) {
        if (*(dword *)(patch[j].info[i].addr) == *(dword *)(patch[j].info[i].to)) {
            if (i == (patch[j].count-1)) {
#ifdef exTAPdebug
                TAP_Print("\n%s(), Firmware is already patched: 0x%08x", __func__, patch[j].info[0].addr);
#endif
                return EXTAPERR_ALREADY_PATCHED;
            }
        }
        else {
            break;
        }
    }

    return EXTAPERR_BAD_MATCH;
}

int exTAP_ApplyPatch(type_patch *patch)
{
    int i;
    int index;
    int ret;

    ret = exTAP_isPatched(patch, &index);
    if (ret == EXTAPERR_NOT_PATCHED) {
        //apply patch
        for (i=0; i<patch[index].count; i++) {
            memcpy((byte *)patch[index].info[i].addr, patch[index].info[i].to, 4);
        }
        ret = EXTAPERR_NONE;
    }
    return ret;
}

int exTAP_RemovePatch(type_patch *patch)
{
    int i;
    int index;
    int ret;

    ret = exTAP_isPatched(patch, &index);
    if (ret == EXTAPERR_ALREADY_PATCHED) {
        //apply patch
        for (i=0; i<patch[index].count; i++) {
            memcpy((byte *)patch[index].info[i].addr, patch[index].info[i].from, 4);
        }
        ret = EXTAPERR_NONE;
    }
    return ret;
}



int exTAP_ApplyPatch2(type_patch2 *patch)
{
    int i,j;
    int match;

    //search though the list looking for a sysid/version match
    match = 0;
    j = 0;
    while (patch[j].sysid) {
        //check firmware version
        if ((patch[j].sysid == fw_sysid) && (patch[j].revision == _appl_version)) {
            match = 1;
            break;
        }
        j++;
    }
    if (!match) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
        TAP_Print("\n");
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }


    //apply patch
    memcpy((byte *)patch[j].addr, patch[j].to, patch[j].length);
    return EXTAPERR_NONE;
}

int exTAP_RemovePatch2(type_patch2 *patch)
{
    int i,j;
    int match;

    //search though the list looking for a sysid/version match
    match = 0;
    j = 0;
    while (patch[j].sysid) {
        //check firmware version
        if ((patch[j].sysid == fw_sysid) && (patch[j].revision == _appl_version)) {
            match = 1;
            break;
        }
        j++;
    }
    if (!match) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
        TAP_Print("\n");
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    //check if firmware is already patched
    for (i=0; i<patch[j].length; i++) {
        if (*(byte *)(patch[j].addr+i) == patch[j].from[i]) {
            if (i == (patch[j].length-1)) {
#ifdef exTAPdebug
                TAP_Print("\n%s(), Firmware is not already patched: 0x%08x", __func__, patch[j].addr);
#endif
                return EXTAPERR_ALREADY_PATCHED;
            }
        }
        else {
            break;
        }
    }

    //check if patched data matches original firmware
    for (i=0; i<patch[j].length; i++) {
        if (*(byte *)(patch[j].addr+i) != patch[j].to[i]) {
#ifdef exTAPdebug
            TAP_Print("\n%x(), Patched data does not match original firmware: 0x%08x", __func__, patch[j].addr+i);
#endif
            return EXTAPERR_BAD_MATCH;
        }
    }

    //apply patch
    memcpy((byte *)patch[j].addr, patch[j].from, patch[j].length);
    return EXTAPERR_NONE;
}


int exTAP_ApplyPatch3(dword addr, byte *from, byte *to, int length)
{
    int i;

    //check if firmware is already patched
    for (i=0; i<length; i++) {
        if (*(byte *)(addr+i) == to[i]) {
            if (i == (length-1)) {
#ifdef exTAPdebug
                TAP_Print("\n%s(), Firmware is already patched: 0x%08x", __func__, addr);
#endif
                return EXTAPERR_ALREADY_PATCHED;
            }
        }
        else {
            break;
        }
    }

    //check if original firmware matches expected data
    for (i=0; i<length; i++) {
        if (*(byte *)(addr+i) != from[i]) {
#ifdef exTAPdebug
            TAP_Print("\n%s(), Original firmware does not match expected: 0x%08x", __func__, addr+i);
#endif
            return EXTAPERR_BAD_MATCH;
        }
    }

    //apply patch
    memcpy((byte *)addr, to, length);
    return EXTAPERR_NONE;
}

//----------------------------------------------------------------------------
static __inline__ int hook_prefix()
{
    //save some registers
    __asm__ __volatile__ (
    ".set noat\n"
    "addiu   $29,$29,0xff70\n"              //addiu   $sp,$sp,-0x90
    "sw      $0, 0x0010($29)\n"             //sw      $0, 0x0010($sp)         save 0
    "sw      $1, 0x0014($29)\n"             //sw      $at,0x0014($sp)         save at
    "sw      $2, 0x0018($29)\n"             //sw      $v0,0x0018($sp)         save v0
    "sw      $3, 0x001c($29)\n"             //sw      $v1,0x001c($sp)         save v1
    "sw      $4, 0x0020($29)\n"             //sw      $a0,0x0020($sp)         save a0
    "sw      $5, 0x0024($29)\n"             //sw      $a1,0x0024($sp)         save a1
    "sw      $6, 0x0028($29)\n"             //sw      $a2,0x0028($sp)         save a2
    "sw      $7, 0x002c($29)\n"             //sw      $a3,0x002c($sp)         save a3

    "sw      $8, 0x0030($29)\n"             //sw      $t0,0x0030($sp)         save t0
    "sw      $9, 0x0034($29)\n"             //sw      $t1,0x0034($sp)         save t1
    "sw      $10,0x0038($29)\n"             //sw      $t2,0x0038($sp)         save t2
    "sw      $11,0x003c($29)\n"             //sw      $t3,0x003c($sp)         save t3
    "sw      $12,0x0040($29)\n"             //sw      $t4,0x0040($sp)         save t4
    "sw      $13,0x0044($29)\n"             //sw      $t5,0x0044($sp)         save t5
    "sw      $14,0x0048($29)\n"             //sw      $t6,0x0048($sp)         save t6
    "sw      $15,0x004c($29)\n"             //sw      $t7,0x004c($sp)         save t7

    "sw      $16,0x0050($29)\n"             //sw      $s0,0x0050($sp)         save s0
    "sw      $17,0x0054($29)\n"             //sw      $s1,0x0054($sp)         save s1
    "sw      $18,0x0058($29)\n"             //sw      $s2,0x0058($sp)         save s2
    "sw      $19,0x005c($29)\n"             //sw      $s3,0x005c($sp)         save s3
    "sw      $20,0x0060($29)\n"             //sw      $s4,0x0060($sp)         save s4
    "sw      $21,0x0064($29)\n"             //sw      $s5,0x0064($sp)         save s5
    "sw      $22,0x0068($29)\n"             //sw      $s6,0x0068($sp)         save s6
    "sw      $23,0x006c($29)\n"             //sw      $s7,0x006c($sp)         save s7

    "sw      $24,0x0070($29)\n"             //sw      $t8,0x0070($sp)         save t8
    "sw      $25,0x0074($29)\n"             //sw      $t9,0x0074($sp)         save t9
    "sw      $26,0x0078($29)\n"             //sw      $k9,0x0078($sp)         save k0
    "sw      $27,0x007c($29)\n"             //sw      $k9,0x007c($sp)         save k1
    "sw      $28,0x0080($29)\n"             //sw      $gp,0x0080($sp)         save gp
    "sw      $29,0x0084($29)\n"             //sw      $sp,0x0084($sp)         save sp
    "sw      $30,0x0088($29)\n"             //sw      $s8,0x0088($sp)         save s8
    "sw      $31,0x008c($29)\n"             //sw      $ra,0x008c($sp)         save ra
    :
    :
    );
}

static __inline__ int hook_postfix()
{
    //restore the registers
    __asm__ __volatile__ (
    ".set noat\n"
    "lw      $31,0x008c($29)\n"             //lw      $ra,0x008c($sp)         restore ra
    "lw      $30,0x0088($29)\n"             //lw      $s8,0x0088($sp)         restore s8
//  "lw      $29,0x0084($29)\n"             //lw      $sp,0x0084($sp)         restore sp
    "lw      $28,0x0080($29)\n"             //lw      $gp,0x0080($sp)         restore gp
    "lw      $27,0x007c($29)\n"             //lw      $k1,0x007c($sp)         restore k1
    "lw      $26,0x0078($29)\n"             //lw      $k0,0x0078($sp)         restore k0
    "lw      $25,0x0074($29)\n"             //lw      $t9,0x0074($sp)         restore t9
    "lw      $24,0x0070($29)\n"             //lw      $t8,0x0070($sp)         restore t8

    "lw      $23,0x006c($29)\n"             //lw      $s7,0x006c($sp)         restore s7
    "lw      $22,0x0068($29)\n"             //lw      $s6,0x0068($sp)         restore s6
    "lw      $21,0x0064($29)\n"             //lw      $s5,0x0064($sp)         restore s5
    "lw      $20,0x0060($29)\n"             //lw      $s4,0x0060($sp)         restore s4
    "lw      $19,0x005c($29)\n"             //lw      $s3,0x005c($sp)         restore s3
    "lw      $18,0x0058($29)\n"             //lw      $s2,0x0058($sp)         restore s2
    "lw      $17,0x0054($29)\n"             //lw      $s1,0x0054($sp)         restore s1
    "lw      $16,0x0050($29)\n"             //lw      $s0,0x0050($sp)         restore s0

    "lw      $15,0x004c($29)\n"             //lw      $s7,0x004c($sp)         restore t7
    "lw      $14,0x0048($29)\n"             //lw      $s6,0x0048($sp)         restore t6
    "lw      $13,0x0044($29)\n"             //lw      $s5,0x0044($sp)         restore t5
    "lw      $12,0x0040($29)\n"             //lw      $s4,0x0040($sp)         restore t4
    "lw      $11,0x003c($29)\n"             //lw      $s3,0x003c($sp)         restore t3
    "lw      $10,0x0038($29)\n"             //lw      $s2,0x0038($sp)         restore t2
    "lw      $9, 0x0034($29)\n"             //lw      $s1,0x0034($sp)         restore t1
    "lw      $8, 0x0030($29)\n"             //lw      $s0,0x0030($sp)         restore t0

    "lw      $7, 0x002c($29)\n"             //lw      $a3,0x002c($sp)         restore a3
    "lw      $6, 0x0028($29)\n"             //lw      $a2,0x0028($sp)         restore a2
    "lw      $5, 0x0024($29)\n"             //lw      $a1,0x0024($sp)         restore a1
    "lw      $4, 0x0020($29)\n"             //lw      $a0,0x0020($sp)         restore a0
    "lw      $3, 0x001c($29)\n"             //lw      $v1,0x001c($sp)         restore v1
    "lw      $2, 0x0018($29)\n"             //lw      $v0,0x0018($sp)         restore v0
    "lw      $1, 0x0014($29)\n"             //lw      $at,0x0014($sp)         restore at
//  "lw      $0, 0x0010($29)\n"             //lw      $0, 0x0010($sp)         restore 0
    "addiu   $29,$29,0x0090\n"              //addiu   $sp,$sp,0x90
    :
    :
    );
}



extern void *hook_entry_generic;

//
//generic - needs patching with fw_tap_dent, fw_tap_table
//
static int hook()
{
    //cannot use anything that relies on $gp here ...
    //i.e. constants only, no variables

    __asm__ __volatile__ ("hook_entry_generic:\n");
    hook_prefix();      //save the original resgiters

    __asm__ __volatile__ (
    ".set noat\n"
    "hook_main:\n"

   "move  $20, $0              \n"     //    move    $s4, $0                //tap_ident = 0

    "patch_hook_main:           \n"     //    a label so we can find this location to patch it
    "li    $21, 0x80177160      \n"     //    li      $s5, FW_TAP_IDENT_1288         !!! firmware specific,  patch this location later !!!
    "li    $22, 0x80176f60      \n"     //    li      $s6, FW_TAP_TABLE_1288         !!! firmware specific,  patch this location later !!!

    "lw    $23, 0($21)          \n"     //    lw      $s7, 0($s5)            //save  initial tap_ident

    "next_tap:                  \n"
    "lw    $19, 0x10($22)       \n"     //    lw      $s3, 0x10($s6)         //tap_entry - 0 if tap not present
    "beqz  $19, tap_not_present \n"     //    beqz    $s3, tap_not_present
    "sw    $20, 0($21)          \n"     //    sw      $s4, 0($s5)            //set current tap_ident
    "lw    $16, 0x1c($19)       \n"     //    lw      $s0, 0x1c($s3)         //event_handler

    "lw    $19, 4($22)          \n"     //    lw      $s3, 4($s6)            //tap gp
    "move  $28, $19             \n"     //    move    $gp, $s3               //set gp

    "li    $4,  0xf100          \n"     //    li      $a0, EVT_HOOK          //event = EVT_HOOK (0xf100)
    "lw    $5,  0x0014($29)     \n"     //    lw      $a1,0x0014($sp)        //param1 = hook id (originally in $at)
    "addiu $6,  $29, 0x10       \n"     //    addiu   $a2, $sp, 0x10         //param2 = pointer to saved registers
    "jalr  $16                  \n"     //    jalr    $s0                    //ret = TAP_EventHandler(event, param1, param2)

    "lw    $19, 0($22)          \n"     //    lw      $s3, 0($s6)            //get firmware gp
    "move  $28, $19             \n"     //    move    $gp, $s3               //restore firmware gp

    "beqz  $2, taps_done0       \n"     //    beqz    $v0, taps_done0        //bail out if v0 == 0, to stop hook from being passed to more taps
    "bltz  $2, taps_doneNEG     \n"     //    bltz    $v0, taps_doneNEG      //bail out if v0 < 0, to force the hook to exit with an 'rts'

    "tap_not_present:           \n"
    "addiu $22, 0x20            \n"     //    addiu   $s6, 0x20              //next tap
    "addiu $20, 1               \n"     //    addiu   $s4, 1                 //next tap_ident
    "sltiu $1, $20, 0x10        \n"     //    sltiu   $at, $s4, 0x10         //got to 16 yet?
    "bnez  $1, next_tap         \n"     //    bnez    $at, next_tap          //go round again

    "taps_done0:                \n"
    "lw    $1, 0x0014($29)      \n"     //    lw      $at,0x0014($sp)        //hook id (originally in $at)
    "sll   $1, $1, 1            \n"     //    sll     $at, $at, 1            //hook id * 2
    "sw    $1, 0x0014($29)      \n"     //    sw      $at,0x0014($sp)        //save modified hook id
    "b     taps_done            \n"     //    b       taps_done              //continue

    "taps_doneNEG:              \n"
    "lw    $1, 0x0014($29)      \n"     //    lw      $at,0x0014($sp)        //hook id (originally in $at)
    "sll   $1, $1, 1            \n"     //    sll     $at, $at, 1            //hook id * 2
    "addiu $1, $1, 0x01         \n"     //    addiu   $at, $at, 0x01         //add 1 if rts
    "sw    $1, 0x0014($29)      \n"     //    sw      $at,0x0014($sp)        //save modified hook id

    "taps_done:                 \n"
    "sw    $23, 0($21)          \n"     //    sw      $s7, 0($s5)            //restore initial tap_ident

    :
    :
    );

    hook_postfix();     //restores the original registers

    __asm__ __volatile__ (
    ".set noat\n"
    "hook_postfix2:\n"

    //a bit crude ...
    "addiu $1, -2               \n"     //    addiu   $at, -2               //0 is not used to allow event to return 0
    "beqz  $1, hook_exit1       \n"     //    beqz    $at, hook_exit1
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit1       \n"     //    beqz    $at, hook_quit1
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit2       \n"     //    beqz    $at, hook_exit2
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit2       \n"     //    beqz    $at, hook_quit2
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit3       \n"     //    beqz    $at, hook_exit3
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit3       \n"     //    beqz    $at, hook_quit3
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit4       \n"     //    beqz    $at, hook_exit4
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit4       \n"     //    beqz    $at, hook_quit4
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit5       \n"     //    beqz    $at, hook_exit5
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit5       \n"     //    beqz    $at, hook_quit5
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit6       \n"     //    beqz    $at, hook_exit6
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit6       \n"     //    beqz    $at, hook_quit6
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit7       \n"     //    beqz    $at, hook_exit7
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit7       \n"     //    beqz    $at, hook_quit7
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit8       \n"     //    beqz    $at, hook_exit8
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit8       \n"     //    beqz    $at, hook_quit8
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit9       \n"     //    beqz    $at, hook_exit9
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit9       \n"     //    beqz    $at, hook_quit9
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit10      \n"     //    beqz    $at, hook_exit10
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit10      \n"     //    beqz    $at, hook_quit10
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit11      \n"     //    beqz    $at, hook_exit11
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit11      \n"     //    beqz    $at, hook_quit11
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit12      \n"     //    beqz    $at, hook_exit12
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit12      \n"     //    beqz    $at, hook_quit12
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit13      \n"     //    beqz    $at, hook_exit13
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit13      \n"     //    beqz    $at, hook_quit13
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit14      \n"     //    beqz    $at, hook_exit14
   "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit14      \n"     //    beqz    $at, hook_quit14
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit15      \n"     //    beqz    $at, hook_exit15
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit15      \n"     //    beqz    $at, hook_quit15
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit16      \n"     //    beqz    $at, hook_exit16
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit16      \n"     //    beqz    $at, hook_quit16
    //broken ...
    "j     hook_quit16          \n"     //    j       hook_quit16
    );
}

//this gets patched with the initially overwritten firmware code (up to 4 words)
//and the jump back into the firmware
static int hook_exit1()
{
    __asm__ __volatile__ (
    "nop\n"                             //  first line of pFunc
    "nop\n"                             //  second line of pFunc
    "nop\n"                             //  j  firmware+8
    "nop\n"
    "nop\n"                             //this gets optimised after the rts ...
    :
    : );
}
static int hook_quit1()
{
    __asm__ __volatile__ (
    "nop\n"                             //  first line of pFunc
    "nop\n"                             //  second line of pFunc
    "nop\n"                             //  j  $ra  (don't do it here, because gcc reoptimises for delay slots
    "nop\n"
    "nop\n"                             //this gets optimised after the rts ...
    :
    : );
}
static int hook_exit2() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit2() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit3() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit3() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit4() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit4() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit5() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit5() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit6() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit6() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit7() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit7() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit8() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit8() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit9() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit9() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit10() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit10() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit11() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit11() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit12() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit12() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit13() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit13() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit14() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit14() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit15() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit15() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_exit16() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit16() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }

//----------------------------------------------------------------------------
typedef struct  {
    type_hook hook;
    dword exit;                 //hook exit address
    dword quit;                 //hook quit address
    byte  to[0x100];            //code patched to firmware
}type_hook_list;

type_hook_list hook_list[1+MAX_HOOKS];

//return -ve = error
//return +ve = hook_handle
int exTAP_ApplyHook(type_hook *hook)
{
    int i,j;
    int ret;
    int match;
    int id;
    dword *hook_entry;

    hook_entry = (dword *)&hook_entry_generic;

    //search though the list looking for a sysid/version match
    match = 0;
    j = 0;
    while (hook[j].sysid) {
        //check firmware version
        if ((hook[j].sysid == fw_sysid) && (hook[j].revision == _appl_version)) {
            match = 1;
            break;
        }
        j++;
    }
    if (!match) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
        TAP_Print("\n");
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }



    if ((hook[j].enable) == 0) {
        //ignore; not enabled
        return EXTAPERR_OTHER;
    }

    //match against an existing
    for (i=1; i<=MAX_HOOKS; i++) {
        if (hook_list[i].hook.enable) {
            if (hook[j].addr == hook_list[i].hook.addr) {
                if (hook[j].length == hook_list[i].hook.length) {
#ifdef exTAPdebug
                    TAP_Print("\n%s(), hook already exists", __func__);
#endif
                    return EXTAPERR_ALREADY_PATCHED;
                }
            }
        }
    }

    //find a spare slot
    id = -1;
    for (i=1; i<=MAX_HOOKS; i++) {
        if (hook_list[i].hook.enable == 0) {
            id = i;
            break;
        }
    }
    if (id < 0) {
#ifdef exTAPdebug
        TAP_Print("\%s(), no more free hooks", __func__);
#endif
        return EXTAPERR_OTHER;
    }


    //save the hook details
    hook_list[id].hook.addr   = hook[j].addr;
    hook_list[id].hook.length = hook[j].length;
    memcpy(hook_list[id].hook.from, hook[j].from, hook[j].length);

//!!!this code produces 9x Warning: Macro used $at after ".set noat"
//seems to be bogus ...
    switch (id) {
        case 1:
            hook_list[id].exit = (dword)hook_exit1;
            hook_list[id].quit = (dword)hook_quit1;
            break;
        case 2:
            hook_list[id].exit = (dword)hook_exit2;
            hook_list[id].quit = (dword)hook_quit2;
            break;
        case 3:
            hook_list[id].exit = (dword)hook_exit3;
            hook_list[id].quit = (dword)hook_quit3;
            break;
        case 4:
            hook_list[id].exit = (dword)hook_exit4;
            hook_list[id].quit = (dword)hook_quit4;
            break;
        case 5:
            hook_list[id].exit = (dword)hook_exit5;
            hook_list[id].quit = (dword)hook_quit5;
            break;
        case 6:
            hook_list[id].exit = (dword)hook_exit6;
            hook_list[id].quit = (dword)hook_quit6;
            break;
        case 7:
            hook_list[id].exit = (dword)hook_exit7;
            hook_list[id].quit = (dword)hook_quit7;
            break;
        case 8:
            hook_list[id].exit = (dword)hook_exit8;
            hook_list[id].quit = (dword)hook_quit8;
            break;
        case 9:
            hook_list[id].exit = (dword)hook_exit9;
            hook_list[id].quit = (dword)hook_quit9;
            break;
        case 10:
            hook_list[id].exit = (dword)hook_exit10;
            hook_list[id].quit = (dword)hook_quit10;
            break;
        case 11:
            hook_list[id].exit = (dword)hook_exit11;
            hook_list[id].quit = (dword)hook_quit11;
            break;
        case 12:
            hook_list[id].exit = (dword)hook_exit12;
            hook_list[id].quit = (dword)hook_quit12;
            break;
        case 13:
            hook_list[id].exit = (dword)hook_exit13;
            hook_list[id].quit = (dword)hook_quit13;
            break;
        case 14:
            hook_list[id].exit = (dword)hook_exit14;
            hook_list[id].quit = (dword)hook_quit14;
            break;
        case 15:
            hook_list[id].exit = (dword)hook_exit15;
            hook_list[id].quit = (dword)hook_quit15;
            break;
        default:
            hook_list[id].exit = (dword)hook_exit16;
            hook_list[id].quit = (dword)hook_quit16;
            break;
    }

    //patch exit
    //the original firwmare code
    exTAP_ApplyPatch3(hook_list[id].exit, (byte *)hook_list[id].exit, &hook_list[id].hook.from[0], hook_list[id].hook.length);
    //a jump back to the firmware                                                   //08xxxxxx j (hook_list[id].hook.addr+hook_list[id].hook.length)
    *(dword *)(hook_list[id].exit + hook_list[id].hook.length + 0x0) = 0x08000000 | (((hook_list[id].hook.addr+hook_list[id].hook.length) & 0x0ffffffc) >> 2);
    *(dword *)(hook_list[id].exit + hook_list[id].hook.length + 0x4) = 0x00000000;  //00000000 nop

    //an rts for patching out functions
    *(dword *)(hook_list[id].quit + 0x0) = 0x03e00008;     //03e00008 jr $ra
    *(dword *)(hook_list[id].quit + 0x4) = 0x00000000;     //00000000 nop
    *(dword *)(hook_list[id].quit + 0x8) = 0x00000000;     //00000000 nop
    *(dword *)(hook_list[id].quit + 0xc) = 0x00000000;     //00000000 nop

    //hook firmware
    *(dword *)((dword)&hook_list[id].to[0]) = 0x08000000 | ((((dword)hook_entry) & 0x0ffffffc) >> 2);  //08xxxxxx j  hook_entry
    *(dword *)((dword)&hook_list[id].to[4]) = 0x24010000 | (id & 0xffff);                               //24010003 li $at, id   //dont use 0
    ret = exTAP_ApplyPatch3(hook_list[id].hook.addr, &hook_list[id].hook.from[0], &hook_list[id].to[0], hook_list[id].hook.length);
    if (ret) {
        return ret;
    }

    hook_list[id].hook.enable = 1;
    return id;
}

int exTAP_RemoveHook(int id)
{
    int ret;

    if ((id <1) || (id > MAX_HOOKS)) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), invalid id - %d", __func__, id);
#endif
        return EXTAPERR_OTHER;
    }
    if (hook_list[id].hook.enable == 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), hook %d is not enabled", __func__, id);
#endif
        return EXTAPERR_OTHER;
    }

    //unhook firmware
    ret = exTAP_ApplyPatch3(hook_list[id].hook.addr, &hook_list[id].to[0], &hook_list[id].hook.from[0], hook_list[id].hook.length);

    if (ret == 0) hook_list[id].hook.enable = 0;
    return ret;
}

//----------------------------------------------------------------------------
//
// Event Routines
//

//
//still need to do:
//   bool exTAP_Hdd_GetPlayInfo(TexYPE_PlayInfo *playInfo);
//
TYPE_exTapEvent *exTAP_GetEvent(int chType, int chNum, int *eventNum)
{
    int i,j;
    TYPE_TapChInfo chInfo;
    int num_events;
    type_eventtable *fw_et;
    TYPE_exTapEvent *evInfo;
    char *description;
    int description_length;
    dword utc, local;

    TAP_Channel_GetInfo(chType, chNum, &chInfo);
    num_events = 0;
    for (i=0; i<fw_max_events; i++) {

        //the sizeof(fw_event_table) is different from 456:1288
        //so, don't use a static index, e.g. fw_event_table[i].
        fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

        //match orgNetId, tsId, svcId
        if (fw_et->char00 & 0xc0) {
            if (chInfo.svcId == fw_et->service_id) {
                if (chInfo.tsId == fw_et->transport_stream_id) {
                    if (chInfo.orgNetId == fw_et->original_network_id) {
                        num_events ++;
                    }
                }
            }
        }
    }
    evInfo = TAP_MemAlloc(num_events * sizeof(TYPE_exTapEvent));

    j = 0;
    for (i=0; i<fw_max_events; i++) {
        fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

        //match satIdx, orgNetId, tsId, svcId
        if (fw_et->char00 & 0xc0) {
            if (chInfo.svcId == fw_et->service_id) {
                if (chInfo.tsId == fw_et->transport_stream_id) {
                    if (chInfo.orgNetId == fw_et->original_network_id) {
                        if (chInfo.satIdx == fw_et->sat_index) {
                            evInfo[j].evtId = fw_et->event_id;
                            //dates are stored internally in utc time, they need converting to local time
                            utc = (fw_et->start_date << 16) + (fw_et->start_hour<<8) + fw_et->start_min;
                            evInfo[j].startTime = exTAP_UTCtoLocalTime(utc);

                            utc = (fw_et->end_date << 16) + (fw_et->end_hour<<8) + fw_et->end_min;
                            evInfo[j].endTime = exTAP_UTCtoLocalTime(utc);

                            evInfo[j].duration = (fw_et->duration_hour << 8) | fw_et->duration_min;
                            if ((fw_sysid==456)&&(_appl_version==0x1288)) {
                                evInfo[j].runningStatus = (fw_et->char00 >> 3) & 0x7;
                            }
                            else {
                                evInfo[j].runningStatus = (fw_et->char00 >> 0) & 0x1f;
                            }

                            memcpy(evInfo[j].eventName, fw_et->event_name, fw_et->event_name_length);
                            evInfo[j].eventName[fw_et->event_name_length] = '\0';

                            description = (char *)((dword)fw_et->event_name + fw_et->event_name_length);
                            description_length = strlen(description);
                            memcpy(evInfo[j].description, description, description_length);
                            evInfo[j].description[description_length] = '\0';

                            evInfo[j].parentalRating = fw_et->parental_rating;
                            evInfo[j].satIdx = fw_et->sat_index;
                            evInfo[j].svcId = fw_et->service_id;
                            evInfo[j].orgNetId = fw_et->original_network_id;
                            evInfo[j].tsId = fw_et->transport_stream_id;
                            j ++;
                        }
                    }
                }
            }
        }
    }

    *eventNum = num_events;
    return evInfo;
}

TYPE_exTapEvent *exTAP_GetCurrentEvent(int chType, int chNum)
{
    int i;
    TYPE_TapChInfo chInfo;
    TYPE_exTapEvent *evInfo;
    type_eventtable *fw_et;
    char *description;
    int description_length;
    dword utc;


    TAP_Channel_GetInfo(chType, chNum, &chInfo);

    evInfo = TAP_MemAlloc(sizeof(TYPE_exTapEvent));

    for (i=0; i<fw_max_events; i++) {
        //the sizeof(fw_event_table) is different from 456:1288
        //so, don't use a static index, e.g. fw_event_table[i].
        fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

        //match satIdx, orgNetId, tsId, svcId

        if (fw_et->char00 & 0xc0) {
            if ((((fw_sysid==456)&&(_appl_version==0x1288))&&(((fw_et->char00>>3) & 0x7) == 4)) ||      //running
                (((fw_sysid!=456)||(_appl_version!=0x1288))&&(((fw_et->char00 & 0x1f) == 4))))          //running
            {
                if (chInfo.svcId == fw_et->service_id) {
                    if (chInfo.tsId == fw_et->transport_stream_id) {
                        if (chInfo.orgNetId == fw_et->original_network_id) {
                            if (chInfo.satIdx == fw_et->sat_index) {
                                evInfo->evtId = fw_et->event_id;
                                //dates are stored internally in utc time, they need converting to local time
                                utc = (fw_et->start_date << 16) + (fw_et->start_hour<<8) + fw_et->start_min;
                                evInfo->startTime = exTAP_UTCtoLocalTime(utc);

                                utc = (fw_et->end_date << 16) + (fw_et->end_hour<<8) + fw_et->end_min;
                                evInfo->endTime = exTAP_UTCtoLocalTime(utc);

                                evInfo->duration = (fw_et->duration_hour << 8) | fw_et->duration_min;
                                if ((fw_sysid==456)&&(_appl_version==0x1288)) {
                                    evInfo->runningStatus = (fw_et->char00 >> 3) & 0x7;
                                }
                                else {
                                    evInfo->runningStatus = (fw_et->char00 >> 0) & 0x1f;
                                }

                                memcpy(evInfo->eventName, fw_et->event_name, fw_et->event_name_length);
                                evInfo->eventName[fw_et->event_name_length] = '\0';

                                description = (char *)((dword)fw_et->event_name + fw_et->event_name_length);
                                description_length = strlen(description);
                                memcpy(evInfo->description, description, description_length);
                                evInfo->description[description_length] = '\0';

                                evInfo->parentalRating = fw_et->parental_rating;
                                evInfo->satIdx = fw_et->sat_index;
                                evInfo->svcId = fw_et->service_id;
                                evInfo->orgNetId = fw_et->original_network_id;
                                evInfo->tsId = fw_et->transport_stream_id;
                                break;
                            }
                        }
                    }
                }
            }
        }
    }

    return evInfo;
}

byte *exTAP_EPG_GetExtInfo(TYPE_exTapEvent *tapEvtInfo)
{
    byte *extInfo;
    int i;
    TYPE_exTapEvent *evInfo;
    type_eventtable *fw_et;
    byte num_extended;
    word extended_length;
    byte *extended_event_name;

    for (i=0; i<fw_max_events; i++) {
        //the sizeof(fw_event_table) is different from 456:1288
        //so, don't use a static index, e.g. fw_event_table[i].
        fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

        //match satIdx, orgNetId, tsId, svcId, evtId,
        if (fw_et->char00 & 0xc0) {
            if (tapEvtInfo->evtId == fw_et->event_id) {
                if (tapEvtInfo->svcId == fw_et->service_id) {
                    if (tapEvtInfo->tsId == fw_et->transport_stream_id) {
                        if (tapEvtInfo->orgNetId == fw_et->original_network_id) {
                            if (tapEvtInfo->satIdx == fw_et->sat_index) {
//!!!the order of the internal type_eventtable structure is different for v12.88!!!
                                if ((fw_sysid==456)&&(_appl_version==0x1288)) {
                                    num_extended = *(byte *)(((dword)&fw_et->event_name)+9);
                                    extended_length = *(word *)(((dword)&fw_et->event_name)+10);
                                    extended_event_name = (byte *)*(dword *)(((dword)&fw_et->event_name)+4);
                                }
                                else {
                                    num_extended = fw_et->num_extended;
                                    extended_length = fw_et->extended_length;
                                    extended_event_name = fw_et->extended_event_name;
                                }
//TAP_Print("\nexTAP_EPG_GetExtInfo(), num_extended        = %02x", num_extended);
//TAP_Print("\nexTAP_EPG_GetExtInfo(), extended_length     = %04x", extended_length);
                                extInfo = TAP_MemAlloc(fw_et->extended_length+2);
                                memcpy(extInfo, extended_event_name, extended_length);
                                extInfo[extended_length] = '\0';
                                extInfo[extended_length+1] = '\0';
                                break;
                            }
                        }
                    }
                }
            }
        }
    }

    return extInfo;
}

bool exTAP_EPG_DeleteEvent(int chType, int chNum, dword evtid)
{
    int i;
    int ret;
    TYPE_TapChInfo chInfo;
    type_eventtable *fw_et;

//    if (fw_max_events <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_tablev) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_delete <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }

    ret = TAP_Channel_GetInfo(chType, chNum, &chInfo);
    if (ret) {
        return 0;
    }

    for (i=0; i<fw_max_events; i++) {
        //the sizeof(fw_event_table) is different from 456:1288
        //so, don't use a static index, e.g. fw_event_table[i].
        fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

        //match satIdx, orgNetId, tsId, svcId, evtId,
        if (fw_et->char00 & 0xc0) {
            if (evtid == fw_et->event_id) {
                if (chInfo.svcId == fw_et->service_id) {
                    if (chInfo.tsId == fw_et->transport_stream_id) {
                        if (chInfo.orgNetId == fw_et->original_network_id) {
                            if (chInfo.satIdx == fw_et->sat_index) {

                                //void fw_event_delete(int event_index);
                                exTAP_CallFirmware(fw_event_delete, i, 0,0,0, 0,0,0,0,0,0,0);
                                return 1;
                            }
                        }
                    }
                }
            }
        }
    }

    return 0;
}

bool exTAP_EPG_UpdateEvent(int chType, int chNum, dword evtid, dword runningStatus)
{
    int i;
    int ret;
    TYPE_TapChInfo chInfo;
    type_eventtable *fw_et;

//    if (fw_max_events <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_table <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }

    ret = TAP_Channel_GetInfo(chType, chNum, &chInfo);
    if (ret) {
        return 0;
    }

    for (i=0; i<fw_max_events; i++) {
        //the sizeof(fw_event_table) is different from 456:1288
        //so, don't use a static index, e.g. fw_event_table[i].
        fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

        //match satIdx, orgNetId, tsId, svcId, evtId,
        if (fw_et->char00 & 0xc0) {
            if (evtid == fw_et->event_id) {
                if (chInfo.svcId == fw_et->service_id) {
                    if (chInfo.tsId == fw_et->transport_stream_id) {
                        if (chInfo.orgNetId == fw_et->original_network_id) {
                            if (chInfo.satIdx == fw_et->sat_index) {
                                if ((fw_sysid==456)&&(_appl_version==0x1288)) {
                                    fw_et->char00 = (fw_et->char00 & 0xc0) | ((runningStatus & 0x7) << 3);
                                }
                                else {
                                    fw_et->char00 = (fw_et->char00 & 0xe0) | (runningStatus & 0x1f);
                                }
                                return 1;
                            }
                        }
                    }
                }
            }
        }
    }

    return 0;
}

//
//a quick way to zap the entire firmware internal event table
//
int exTAP_EPG_DeleteAllEvents(void)
{
    int i;
    int num_events;
    type_eventtable *fw_et;

//    if (fw_max_events <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_table <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_delete <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }

    num_events = 0;
    for (i=0; i<fw_max_events; i++) {
        //the sizeof(fw_event_table) is different from 456:1288
        //so, don't use a static index, e.g. fw_event_table[i].
        fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

        if (fw_et->char00 & 0xc0) {
            //void fw_event_delete(int event_index);
            exTAP_CallFirmware(fw_event_delete, i, 0,0,0, 0,0,0,0,0,0,0);
            num_events ++;
        }
    }
    return num_events;
}

int exTAP_EPG_GetNumEvents(void)
{
    int i;
    int num_events;
    type_eventtable *fw_et;

//    if (fw_max_events <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_table <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }

    num_events = 0;
    for (i=0; i<fw_max_events; i++) {
        //the sizeof(fw_event_table) is different from 456:1288
        //so, don't use a static index, e.g. fw_event_table[i].
        fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

        if (fw_et->char00 & 0xc0) {
            num_events ++;
        }
    }
    return num_events;
}

//----------------------------------------------------------------------------
//only for 12.88
int exTAP_GetCurrentGenre(int chType, int chNum, int *nibble1, int *nibble2)
{
    TYPE_TapChInfo channel_info;
    type_eventtable *fw_et;
    int event_index;
    int i,j,k;
    int running_status;

    *nibble1 = 0;
    *nibble2 = 0;
    if ((fw_sysid==456)&&(_appl_version==0x1288)) {
        TAP_Channel_GetInfo(chType, chNum, &channel_info);

        //goto the start of the chain
        event_index = 0;
        k = 0;
        while (k < fw_max_events) {
            //the sizeof(fw_event_table) is different from 456:1288
            //so, don't use a static index, e.g. fw_event_table[i].
            fw_et = (type_eventtable *)((dword)fw_event_table + (event_index * fw_event_table_size));

            if ((fw_et->char00 & 0xc0) == 0) {
                //find a valid entry
                event_index++;
            }
            else {
                //is this the start
                if (fw_et->previous == 0xffff) {
                    break;
                }
                event_index = fw_et->previous;
            }
            k++;
        }
        if (k == fw_max_events) {
            //epg empty
#ifdef exTAPdebug
            TAP_Print("\nepg empty");
#endif
            return EXTAPERR_OTHER;
        }

        j = event_index;
        k = 0;
        //find the curent program
        while(k < fw_max_events) {
            fw_et = (type_eventtable *)((dword)fw_event_table + (j * fw_event_table_size));

            //match service_id
            if (fw_et->service_id == channel_info.svcId) {
//                running_status = (fw_et->char00 >> 0) & 0x1f;   //pre12.88
                running_status = (fw_et->char00 >> 3) & 7;      //12.88
                if (running_status == 4) {
                    //get the genre type
                    *nibble1 = fw_et->content_nibble1;
                    *nibble2 = fw_et->content_nibble2;
                    break;
                }
            }
            j = fw_et->next;
            if (j == 0xffff) {
#ifdef exTAPdebug
                TAP_Print("\ncurrent program not found");
#endif
                return EXTAPERR_OTHER;
            }
            k++;
        }
    }
   else {
        //not with this firmware
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }
    return 0;
}

//only for 12.88
int exTAP_GetGenre(TYPE_TapEvent *tapEvtInfo, int *nibble1, int *nibble2)
{
    int i;
    type_eventtable *fw_et;

    *nibble1 = 0;
    *nibble2 = 0;
    if (!fw_max_events) goto exit;
    if (!fw_event_table_size) goto exit;
    if (!fw_event_table) goto exit;
    if ((fw_sysid==456)&&(_appl_version==0x1288)) {
        for (i=0; i<fw_max_events; i++) {
            //the sizeof(fw_event_table) is different from 456:1288
            //so, don't use a static index, e.g. fw_event_table[i].
            fw_et = (type_eventtable *)((dword)fw_event_table + (i * fw_event_table_size));

            //match satIdx, orgNetId, tsId, svcId, evtId,
            if (fw_et->char00 & 0xc0) {
                if (tapEvtInfo->evtId == fw_et->event_id) {
                    if (tapEvtInfo->svcId == fw_et->service_id) {
                        if (tapEvtInfo->tsId == fw_et->transport_stream_id) {
                            if (tapEvtInfo->orgNetId == fw_et->original_network_id) {
                                if (tapEvtInfo->satIdx == fw_et->sat_index) {
                                    //get the genre type
                                    *nibble1 = fw_et->content_nibble1;
                                    *nibble2 = fw_et->content_nibble2;
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return 0;

exit:
    //not with this firmware
#ifdef exTAPdebug
    TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
    return EXTAPERR_BAD_FIRMWARE;
}
//
// alter the size of the internal epg short event/extended event buffers
// default: 0x80000 (512K), allows ~3000 events
// better:  0x100000 (1M), allows 5000 events
// extended events are likely to need less, unless populated from external source
//
int exTAP_EPG_Resize(dword short_size, dword ext_size)
{
    byte *shortb_ptr;
    byte *extb_ptr;
    int ret;

//    if (fw_max_events <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_table <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_delete <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_buffer <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_os_free <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }
//    if (fw_event_alloc <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }

    //not for 1288
    if ((fw_sysid==456)&&(_appl_version==0x1288)) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

//TAP_Print("\nexTAP_EPG_Resize(short_size=%x, ext_size=%x)", short_size, ext_size);

    //delete the epg
    exTAP_EPG_DeleteAllEvents();

    //free epg
    shortb_ptr = fw_event_buffer->short_event_buffer;       //short events
    extb_ptr   = fw_event_buffer->extended_event_buffer;    //extended events

    //call os_free
    ret = exTAP_CallFirmware(fw_os_free, (dword)shortb_ptr, 0,0,0, 0,0,0,0,0,0,0); //short events
    ret = exTAP_CallFirmware(fw_os_free, (dword)extb_ptr, 0,0,0, 0,0,0,0,0,0,0);   //extended events

    //alloc epg
    ret = exTAP_CallFirmware(fw_event_alloc, 0, short_size, 0,0, 0,0,0,0,0,0,0); //short events
//ret=addr 0=fail
    if (ret = 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), failed, short_size=%x", __func__, short_size);
#endif
    }
    ret = exTAP_CallFirmware(fw_event_alloc, 1, ext_size, 0,0, 0,0,0,0,0,0,0);   //extended events
    if (ret = 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), failed, ext_size=%x", __func__, ext_size);
#endif
    }

    return 0;
}

int exTAP_EPG_GetSize(int type)
{
    int len;

//    if (fw_event_buffer <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }

    //not for 1288
    if ((fw_sysid==456)&&(_appl_version==0x1288)) {
        if (type == 1) {
#ifdef exTAPdebug
            TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
            return EXTAPERR_BAD_FIRMWARE;
        }
    }
//TAP_Print("\nexTAP_EPG_GetSize(%s)", (type)?"Extended Event" : "Short Event");

    if (type == 0) {
        len = 32 * fw_event_buffer->short_event_blocks;     //short event (size is in blocks, 32 byte per block)
    }
    else {
        len = 32 * fw_event_buffer->extended_event_blocks;  //extended event
    }
//TAP_Print(", size=%x", len);

    return len;
}

//----------------------------------------------------------------------------
//
//eit schedule patch
//
//this patch changes the eit filter/mask to enable the eit schedule information
//for the other muxes, as well as the currrent mux.  It also removes the service_id
//filter to enusre more rapid filling of the EPG.
//this patch should be used in conjunction with enlarging the EPG database to ensure
//that there is space for 5000 entries.
//
//
//    80181fbc 34 07 f0 50                             li      $a3, 0xf050            # 5x
//--> 80181fbc 34 07 ce 50                             li      $a3, 0xce50            # 40,41,50,51,60,61,70,71
//--> 80181fbc 34 07 c0 50                             li      $a3, 0xc050            # 4x,5x,6x,7x
//
//    80181e90 8f b6 00 78                             lw      $s6, 0x68+0x78($sp)    #
//--> 80181e90 34 16 ff ff                             li      $s6, 0xffff            # jam tid_ext = 0xffff
//
type_patch eit_schedule_patch[] = {
    {
        456,
        0x1204,
        2,
        {
            0x801801c0, {0x34, 0x07, 0xf0, 0x50 }, {0x34, 0x07, 0xce, 0x50 },
            0x80180094, {0x8f, 0xb6, 0x00, 0x78 }, {0x34, 0x16, 0xff, 0xff },
        },
    },
    {
        456,
        0x1205,
        2,
        {
            0x80180344, {0x34, 0x07, 0xf0, 0x50 }, {0x34, 0x07, 0xce, 0x50 },
            0x80180218, {0x8f, 0xb6, 0x00, 0x78 }, {0x34, 0x16, 0xff, 0xff },
        },
    },
    {
        456,
        0x1209,
        2,
        {
            0x80180ec0, {0x34, 0x07, 0xf0, 0x50 }, {0x34, 0x07, 0xce, 0x50 },
            0x80180d94, {0x8f, 0xb6, 0x00, 0x78 }, {0x34, 0x16, 0xff, 0xff },
        },
    },
    {
        456,
        0x1225,
        1,
        {
//            0x80181fbc, {0x34, 0x07, 0xf0, 0x50 }, {0x34, 0x07, 0xce, 0x50 },       //40,41,50,51,60,61,70,71
//          0x80181fbc, {0x34, 0x07, 0xf0, 0x50 }, {0x34, 0x07, 0xc0, 0x50 },       //4x,5x,6x,7x
            0x80181e90, {0x8f, 0xb6, 0x00, 0x78 }, {0x34, 0x16, 0xff, 0xff },
        },
    },
};

int exTAP_EIT_Schedule(int enable)
{
    if (enable) {
        return exTAP_ApplyPatch(eit_schedule_patch);
    }
    else {
        return exTAP_RemovePatch(eit_schedule_patch);
    }
}

//----------------------------------------------------------------------------
//
//eit nownext patch
//
//this patch changes the eit filter/mask to enable the eit nownext information
//for the other muxes, as well as the currrent mux.  It also removes the service_id
//filter to ensure more rapid filling of the EPG.
//this patch should be used in conjunction with enlarging the EPG database to ensure
//that there is space for 5000 entries.
//
//
//80182070 24 06 00 12                             li      $a2, 0x12
//80182074 0c 06 07 12                             jal     set_pid_section_filter_01
//80182078 34 07 ff 4e                             li      $a3, 0xff4e
//
//8018208c 24 06 00 12                             li      $a2, 0x12
//80182090 0c 06 06 50                             jal     set_pid_section_filter_00
//80182094 34 07 ff 4e                             li      $a3, 0xff4e
//
//801821e4 24 06 00 12                             li      $a2, 0x12
//801821e8 0c 06 06 50                             jal     set_pid_section_filter_00
//801821ec 34 07 ff 4f                             li      $a3, 0xff4f
//
//80182204 24 06 00 12                             li      $a2, 0x12
//80182208 0c 06 06 50                             jal     set_pid_section_filter_00
//8018220c 34 07 ff 4f                             li      $a3, 0xff4f
//
//filter_00
//    80181950 8f b6 00 78                         lw      $s6, 0x68+0x78($sp)
//--> 80181950 34 16 ff ff                         li      $s6, 0xffff
//
//filter_01
//    80181c5c 8f b6 00 80                         lw      $s6, 0x68+0x80($sp)
//--> 80181c5c 34 16 ff ff                         li      $s6, 0xffff
//

type_patch eit_nownext_patch[] = {
    {
        456,
        0x1225,
        4,
        {
            0x80181950, {0x8f, 0xb6, 0x00, 0x78 }, {0x34, 0x16, 0xff, 0xff },      //filter_00: service_id=ffff
            0x80181c5c, {0x8f, 0xb6, 0x00, 0x80 }, {0x34, 0x16, 0xff, 0xff },      //filter_01: service_id=ffff

            0x80182078, {0x34, 0x07, 0xff, 0x4e }, {0x34, 0x07, 0xfe, 0x4e },      //change 4e -> 4e,4f
            0x80182094, {0x34, 0x07, 0xff, 0x4e }, {0x34, 0x07, 0xfe, 0x4e },      //change 4e -> 4e,4f

//            0x801821ec, {0x34, 0x07, 0xff, 0x4f }, {0x34, 0x07, 0xfe, 0x4f },    //change 4f -> 4e,4f
//            0x8018220c, {0x34, 0x07, 0xff, 0x4f }, {0x34, 0x07, 0xfe, 0x4f },    //change 4f -> 4e,4f
        },
    },
};

int exTAP_EIT_NowNext(int enable)
{
    if (enable) {
        return exTAP_ApplyPatch(eit_nownext_patch);
    }
    else {
        return exTAP_RemovePatch(eit_nownext_patch);
    }
}

//----------------------------------------------------------------------------
//
//eit stick patch
//
//this patch changes the epg to prevent channel change when viewing other epg channels
//
//

type_patch epg_stick_patch[] = {
    {
        456,
        0x1225,
        1,
        {
            0x80120778, {0x00, 0x18, 0xc7, 0xc2 }, {0x24, 0x18, 0x00, 0x01 },
        },
    },
};

int exTAP_EPG_Stick(int enable)
{
    if (enable) {
        return exTAP_ApplyPatch(epg_stick_patch);
    }
    else {
        return exTAP_RemovePatch(epg_stick_patch);
    }
}

//----------------------------------------------------------------------------
//
// key mapping patch
//
// this patch modifies the EVT_KEY function
// when enabled, param2 contains a pointer to the original key code
// the original key code can be used to differentiate between the
//   ch+/up, ch-/down, vol+/left, vol-/right, tv_radio/list keys
// it allows allows a modified key to be passed back to the firmware
// the return value is passed onto the nxt tap in param1 (must be a remapped keycode)
// if the return value is zero, the key is not passed to the firmware
// if the return value is not zero, the contents of param2 is passed to the firmware (must be an original keycode)
//
// if this patch is enabled, a normal tap will behave exactly as before (as long as it ignores param2)
//

//type_firmware fwlist_key_map_patch[] = {
//    {  456, 0x0000, 0x8012a354},
//    {  456, 0x1204, 0x8012c988},
//    {  456, 0x1205, 0x8012cb0c},
//    {  456, 0x1209, 0x8012d02c},
//    {  456, 0x1225, 0x8012dc48},
//    {  456, 0x1288, 0x80131454},
//    {  406, 0x0000, 0x00000000},
//    {  406, 0x1205, 0x00000000},
//    {13406, 0x1205, 0x00000000},
//    {0, 0, 0},
//};

type_patch key_map_patch[] = {
    {//12.04
        456,
        0x1204,
        7,
        {
            0x8012c988, {0xaf, 0x22, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},
            0x8012c9b0, {0x8f, 0xd1, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},
            0x8012c9e0, {0x00, 0x00, 0x30, 0x25}, {0x03, 0xc0, 0x30, 0x25},
            0x8012c9e4, {0xaf, 0xc2, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},
            0x8012ca14, {0x8f, 0xd9, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},
            0x8012ca18, {0x53, 0x20, 0x00, 0x03}, {0x56, 0x20, 0x00, 0x03},
            0x8012ca20, {0xaf, 0xd6, 0x00, 0x00}, {0xaf, 0xb1, 0x00, 0x00},
        },
    },
    {//12.05
        456,
        0x1205,
        7,
        {
            0x8012cb0c, {0xaf, 0x22, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},
            0x8012cb34, {0x8f, 0xd1, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},
            0x8012cb64, {0x00, 0x00, 0x30, 0x25}, {0x03, 0xc0, 0x30, 0x25},
            0x8012cb68, {0xaf, 0xc2, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},
            0x8012cb98, {0x8f, 0xd9, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},
            0x8012cb9c, {0x53, 0x20, 0x00, 0x03}, {0x56, 0x20, 0x00, 0x03},
            0x8012cba4, {0xaf, 0xd6, 0x00, 0x00}, {0xaf, 0xb1, 0x00, 0x00},
        },
    },
    {//12.09
        456,
        0x1209,     //firmware revision
        7,          //patch count
        {
        //  address,    original data,            new data
            0x8012d02c, {0xaf, 0x22, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},     //  sw    $v0, 0($t9)           move  $s1, $v0
            0x8012d054, {0x8f, 0xd1, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},     //  lw    $s1, 0x00($fp)        nop
            0x8012d084, {0x00, 0x00, 0x30, 0x25}, {0x03, 0xc0, 0x30, 0x25},     //  move  $a2, $0               move  $a2, $fp
            0x8012d088, {0xaf, 0xc2, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},     //  sw    $v0, 0x00($fp)        move  $s1, $v0
            0x8012d0b8, {0x8f, 0xd9, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},     //  lw    $t9, 0x00($fp)        nop
            0x8012d0bc, {0x53, 0x20, 0x00, 0x03}, {0x56, 0x20, 0x00, 0x03},     //  beqzl $t9, 0x8012d0cc       bnezl $s1, 0x8012d0cc
            0x8012d0c4, {0xaf, 0xd6, 0x00, 0x00}, {0xaf, 0xb1, 0x00, 0x00},     //  sw    $s6, 0x00($fp)        sw    $s1, 0x00($fp)
        },
    },
    {//12.25
        456,
        0x1225,
        7,
        {
            0x8012dc48, {0xaf, 0x22, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},
            0x8012dc70, {0x8f, 0xd1, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},
            0x8012dca0, {0x00, 0x00, 0x30, 0x25}, {0x03, 0xc0, 0x30, 0x25},
            0x8012dca4, {0xaf, 0xc2, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},
            0x8012dcd4, {0x8f, 0xd9, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},
            0x8012dcd8, {0x53, 0x20, 0x00, 0x03}, {0x56, 0x20, 0x00, 0x03},
            0x8012dce0, {0xaf, 0xd6, 0x00, 0x00}, {0xaf, 0xb1, 0x00, 0x00},
        },
    },
    {//12.88
        456,
        0x1288,
        7,
        {
            0x80131454, {0xaf, 0x22, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},
            0x8013147c, {0x8f, 0xd1, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},
            0x801314ac, {0x00, 0x00, 0x30, 0x25}, {0x03, 0xc0, 0x30, 0x25},
            0x801314b0, {0xaf, 0xc2, 0x00, 0x00}, {0x00, 0x40, 0x88, 0x25},
            0x801314e0, {0x8f, 0xd9, 0x00, 0x00}, {0x00, 0x00, 0x00, 0x00},
            0x801314e4, {0x53, 0x20, 0x00, 0x03}, {0x56, 0x20, 0x00, 0x03},
            0x801314ec, {0xaf, 0xd6, 0x00, 0x00}, {0xaf, 0xb1, 0x00, 0x00},
        },
    },
};

int exTAP_Key_Extend(int enable)
{
    if (enable) {
        return exTAP_ApplyPatch(key_map_patch);
    }
    else {
        return exTAP_RemovePatch(key_map_patch);
    }
}

//----------------------------------------------------------------------------
//
// mheg off patch
//
// this patch disables the dsmcc processing in the firmware
// it does not disable the mheg engine from operating if any previously acquired data is present
// changing channels will flush the dsmcc file caches
//
//patch out dsmcc handler
//801aacfc 27 bd ff e0   addiu $sp, -0x20               03 e0 00 08    jr   $ra
//801aad00 af b6 00 18   sw    $s6, 0x18($sp)           00 00 00 00    nop

//type_firmware fwlist_mheg_off_patch[] = {
//    {  456, 0x0000, 0x00000000},
//    {  456, 0x1204, 0x00000000},
//    {  456, 0x1205, 0x00000000},
//    {  456, 0x1209, 0x00000000},
//    {  456, 0x1225, 0x801ab730},
//    {  456, 0x1288, 0x801b3124},
//    {  406, 0x0000, 0x00000000},
//    {  406, 0x1205, 0x00000000},
//    {13406, 0x1205, 0x00000000},
//    {0, 0, 0},
//};

type_patch mheg_off_patch[] = {
    {//12.04
        456,
        0x1204,
        2,
        {
            0x801ab874, {0x27, 0xbd, 0xff, 0xc8}, {0x03, 0xe0, 0x00, 0x08},
            0x801ab878, {0xaf, 0xb3, 0x00, 0x24}, {0x00, 0x00, 0x00, 0x00},
        }
    },
    {//12.05
        456,
        0x1205,
        2,
        {
            0x801ab9f8, {0x27, 0xbd, 0xff, 0xc8}, {0x03, 0xe0, 0x00, 0x08},
            0x801ab9fc, {0xaf, 0xb3, 0x00, 0x24}, {0x00, 0x00, 0x00, 0x00},
        }
    },
    {//12.09
        456,        //system id
        0x1209,     //firmware revision
        2,          //patch count
        {
        //  address,    original data,            new data
            0x801aacfc, {0x27, 0xbd, 0xff, 0xe0}, {0x03, 0xe0, 0x00, 0x08},     //  addiu $sp, -0x20            jr   $ra
            0x801aad00, {0xaf, 0xb6, 0x00, 0x18}, {0x00, 0x00, 0x00, 0x00},     //  sw    $s6, 0x18($sp)        nop
        }
    },
    {//12.25
        456,
        0x1225,
        2,
        {
            0x801AB730, {0x27, 0xbd, 0xff, 0x78}, {0x03, 0xe0, 0x00, 0x08},
            0x801AB734, {0xaf, 0xb6, 0x00, 0x80}, {0x00, 0x00, 0x00, 0x00},
        }
    },
    {//12.88
        456,
        0x1288,
        2,
        {
            0x801b3124, {0x27, 0xbd, 0xff, 0x78}, {0x03, 0xe0, 0x00, 0x08},
            0x801b3128, {0xaf, 0xb6, 0x00, 0x80}, {0x00, 0x00, 0x00, 0x00},
        }
    },
};

int exTAP_MHEG_Disable(int disable)
{
    if (disable) {
        return exTAP_ApplyPatch(mheg_off_patch);
    }
    else {
        return exTAP_RemovePatch(mheg_off_patch);
    }
}

int exTAP_MHEG_isPatched()
{
    int ret;

    ret = exTAP_isPatched(mheg_off_patch, NULL);
    if (ret == EXTAPERR_NOT_PATCHED) return 0;
    if (ret == EXTAPERR_ALREADY_PATCHED) return 1;
    return ret;
}

dword exTAP_MHEG_Status()
{
    dword v0,v1;
    dword register_group;

    if (fw_mheg_entry <= 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    register_group = 0;
    v0 = *fw_mheg_entry;
    if (v0) {
        v1 = *(dword *)(v0 + 0x8);
        if (v1) {
            register_group = *(dword *)(v1 + 0x34);
        }
    }

    //see  dtt mheg-5 spec. v1.06, section 3.6
    //if register_group == 0 then no mheg is running
    //if register_group == 3 then mheg is running, has claimed <text><red><green><yellow><blue>
    //if register_group == 5 then mheg is running, has claimed group3 + <arrow keys>
    //if register_group == 4 then mheg is running, has claimed group3 + group5 + <number keys>
    return register_group;
}
//---------------------------------------------------------------------
//
// TAP Load function
//
// this function installs a tap
//
int exTAP_TAP_Load(char *filename)
{
    int ret;

    if ((fw_tap_load  <= 0) || (fw_tap_load_data0 <= 0) || (fw_tap_load_data1 <= 0) || (fw_tap_load_data2 <= 0)) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    *fw_tap_load_data0 = *fw_tap_load_data1;
    ret = exTAP_CallFirmware(fw_tap_load, (dword)filename, 0,0,0, 0,0,0,0,0,0,0);
    *fw_tap_load_data0 = *fw_tap_load_data2;

    return ret;     //the tap load address, 0=fail,
}

//---------------------------------------------------------------------
//
// TAP Shutdown function
//
// this function shuts down the box
//
#define FW_SHUTDOWN_TASK        0xef00          //the shutdown task id

int exTAP_Shutdown(void)
{
    if (fw_add_task_queue <= 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    exTAP_CallFirmware((void *)fw_add_task_queue, FW_SHUTDOWN_TASK, 0x0, 0,0, 0,0,0,0,0,0,0);       //task_ef00

    return 0;
}

//---------------------------------------------------------------------
//
// Front Panel LED Patch
//
// this function patches the firmware to allow the front panel display to be manipulated
//


//80006330 27 bd ff d8   addiu $sp, -0x28               # change to: 03 e0 00 08   jr   $ra
//80006334 af b6 00 20   sw    $s6, 0x20($sp)           # change to: 00 00 00 00   nop
type_patch led_patch[] = {
    {//12.04
        456,
        0x1204,     //firmware revision
        2,
        {
            0x800062dc, {0x27, 0xbd, 0xff, 0xd8}, {0x03, 0xe0, 0x00, 0x08},
            0x800062e0, {0xaf, 0xb6, 0x00, 0x20}, {0x00, 0x00, 0x00, 0x00},
        }
    },
    {//12.05
        456,
        0x1205,     //firmware revision
        2,
        {
            0x800062dc, {0x27, 0xbd, 0xff, 0xd8}, {0x03, 0xe0, 0x00, 0x08},
            0x800062e0, {0xaf, 0xb6, 0x00, 0x20}, {0x00, 0x00, 0x00, 0x00},
        }
    },
    {//12.09
        456,
        0x1209,     //firmware revision
        2,
        {
            0x80006330, {0x27, 0xbd, 0xff, 0xd8}, {0x03, 0xe0, 0x00, 0x08},
            0x80006334, {0xaf, 0xb6, 0x00, 0x20}, {0x00, 0x00, 0x00, 0x00},
        }
    },
    {//12.25
        456,
        0x1225,     //firmware revision
        2,
        {
            0x80006320, {0x27, 0xbd, 0xff, 0xd8}, {0x03, 0xe0, 0x00, 0x08},
            0x80006324, {0xaf, 0xb6, 0x00, 0x20}, {0x00, 0x00, 0x00, 0x00},
        }
    },
    {//12.88
        456,
        0x1288,     //firmware revision
        2,
        {
            0x80006320, {0x27, 0xbd, 0xff, 0xd8}, {0x03, 0xe0, 0x00, 0x08},
            0x80006324, {0xaf, 0xb6, 0x00, 0x20}, {0x00, 0x00, 0x00, 0x00},
        }
    },
};

//pointless...
int exTAP_LED_GetStatus(void)
{
    return 2;
}

int exTAP_LED_SetControl(int enable)
{
    int ret;

    if (fw_display_string <= 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }


    if (enable) {
//TAP_Print("\nApplying LED Patch");
        ret = exTAP_ApplyPatch(led_patch);
    }
    else {
//TAP_Print("\nRemoving LED Patch");
        ret = exTAP_RemovePatch(led_patch);
        // restore display
        exTAP_LED_SendData(0x1f, fw_display_string);
    }
    return ret;
}

int exTAP_LED_GetControl(void)
{
    int ret;

    //check if firmware is already patched
    ret = exTAP_isPatched(led_patch, NULL);
    if (ret == EXTAPERR_NOT_PATCHED) {
        return 0;
    }
    if (ret == EXTAPERR_ALREADY_PATCHED) {
        return 1;
    }
    return ret;
}


//since the original function has been patched with an 'rts' we need to
//replicate the first 2 instructions, then jump into the firmware function
//at an address offset of 8
static int patched_led_string(void *pFunc)
{
    //cannot use anything that relies on $gp here ..

    __asm__ __volatile__ (
    "or      $08,$00,%0\n"          //or      $t0,$00,pFunc
    "addiu   $08,$08,0x08\n"        //addiu   $t0,$t0,0x08            adjust function entry by 8

    "or      $04,$00,$05\n"         //or      $a0,$00,$a1
    "or      $05,$00,$06\n"         //or      $a1,$00,$a2

    "addiu   $29,$29,0xffd8\n"      //addiu   $sp,$sp,-0x28           first line of pFunc
    "sw      $22,0x0020($29)\n"     //sw      $s6,0x0020($sp)         second line of pFunc

    "jr      $08\n"                 //jr      $t0                     call pFunc(mask, pData)
    :
    : "r"(pFunc));
}

//
// This is a call wrapper for the firmware function displaying
// the specified bytes on the seven segment display of TF5000.
void exTAP_LED_SendData(byte mask, byte *pData)
{
//    exTAP_CallFirmware(patched_led_string, led_patch[firmware_id].info[0].addr, mask, (dword)pData, 0, 0,0,0,0,0,0,0);

    if (fw_display_func <= 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return;
    }
    exTAP_CallFirmware(patched_led_string, (dword)fw_display_func, mask, (dword)pData, 0, 0,0,0,0,0,0,0);
}

// This function wraps around the call to a firmware function.
// display elements
//
// control mask
//  bit0 : update first 7-segment from pData[0]
//  bit1 : update second 7-segment from pData[1]
//  bit2 : update third 7-segment from pData[2]
//  bit3 : update fourth 7-segment from pData[3]
//  bit4 : update additional signals from pData[4]
//
// pData should point to an array of 5 bytes
// The first four bytes in the pData array represent the
// seven segment + dot indicators from left to right.
// Bit assignment for seven segment + dor indicators:
//
//     b0
//     --
//  b5|  | b1
//     -- b6
//  b4|  | b2
//     -- o b7 (dot)
//     b3
//
// The fifth byte (pData[4]) represents the state of the
// additional signals (colon, upper dot and LEDs).
// Bit assignment in the fifth byte for additional signals:
//                        b2
//  b5  --     --  b0 --  O  --
//  O  |  |   |  | O |  |   |  |
//  O   --     --  b1 --     --
//  b4 |  |   |  | O |  |   |  |
//      --  o  --  o  --  o  --  o
//
//  b0 - upper dot in the colon
//  b1 - lower dot in the colon
//  b2 - upper dot
//  b4 - green LED
//  b5 - amber LED
//

//these characters are pretty poor...   KM TUVW  ek m uvw

byte charMap[] = {0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                  0x00,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x80,0x40,0x80,0x08,     //spc,-.
                  0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x27, 0x7f,0x6f,0x08,0x08,0x08,0x08,0x08,0x08,     //0-9

                  0x08,0x77,0x7f,0x39,0x3f,0x79,0x71,0x3d, 0x76,0x06,0x1e,0x76,0x38,0x4f,0x37,0x3f,     //,A-O
                  0x73,0xbf,0x77,0x6d,0x78,0x3e,0x3e,0xbe, 0x76,0x6e,0x5b,0x08,0x08,0x08,0x08,0x08,     //P-Z
                  0x08,0xdc,0x7c,0x58,0x5e,0x7b,0x71,0x6f, 0x74,0x04,0x0e,0x76,0x30,0x4f,0x54,0x5c,     //,a-o
                  0x73,0x67,0x50,0x6d,0x78,0x1c,0x1c,0x9c, 0x76,0x6e,0x5b,0x08,0x08,0x08,0x08,0x08,     //p-z

                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,

                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                  0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, 0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,
                 };


int exTAP_LED_GetMap(char ascii)
{
    return charMap[ascii];

}

int exTAP_LED_SetMap(char ascii, byte sevenseg)
{
    charMap[ascii] = sevenseg;
   return 0;
}

//
// This function translates the specified ASCII string
// to a seven-segment character representation.
int exTAP_LED_Translate(const char *pIn, byte *pOut)
{
    int count = 0;

    while (*pIn != 0) {

        *pOut = charMap[*pIn];

        if ((*(pIn + 1) == '.') || (*(pIn + 1) == ',')) {
            // The next character is a dot or a comma, merge it
            // with the current character if the dot is not
            // already in use.
            if (!(*pOut & 0x80)) {
                *pOut |= 0x80;
                pIn++;
            }
        }

        pIn++;
        pOut++;
        count++;
    }
    return count;
}

//-----------------------------------------------------------------------------
//
//
//
int exTAP_GetUTCTime(word *mjd, byte *hour, byte *minute)
{
//    if (fw_utc_time <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }

    *mjd = fw_utc_time->mjd;
    *hour = fw_utc_time->hour;
    *minute = fw_utc_time->minute;
    return 0;
}

//
//
//
dword exTAP_UTCtoLocalTime(dword utc)
{
//    if (fw_utctolocal_time <= 0) {
//        return EXTAPERR_BAD_FIRMWARE;
//    }

    return exTAP_CallFirmware(fw_utctolocal_time, utc,  0,0,0, 0,0,0,0,0,0,0);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
